diff --git a/doc/filters.texi b/doc/filters.texi
index d4fbb5a..65eef89 100644
--- a/doc/filters.texi
+++ b/doc/filters.texi
@@ -3795,7 +3795,7 @@ Set level of input signal of original channel. Default is 0.8.
 @section surround
 Apply audio surround upmix filter.
 
-This filter allows to produce multichannel output from stereo audio stream.
+This filter allows to produce multichannel output from audio stream.
 
 The filter accepts the following options:
 
@@ -3806,6 +3806,12 @@ Set output channel layout. By default, this is @var{5.1}.
 See @ref{channel layout syntax,,the Channel Layout section in the ffmpeg-utils(1) manual,ffmpeg-utils}
 for the required syntax.
 
+@item chl_in
+Set input channel layout. By default, this is @var{stereo}.
+
+See @ref{channel layout syntax,,the Channel Layout section in the ffmpeg-utils(1) manual,ffmpeg-utils}
+for the required syntax.
+
 @item level_in
 Set input volume level. By default, this is @var{1}.
 
diff --git a/libavfilter/af_surround.c b/libavfilter/af_surround.c
index c7d86a5..ee5e601 100644
--- a/libavfilter/af_surround.c
+++ b/libavfilter/af_surround.c
@@ -30,6 +30,7 @@ typedef struct AudioSurroundContext {
     const AVClass *class;
 
     char *out_channel_layout_str;
+    char *in_channel_layout_str;
     float level_in;
     float level_out;
     int output_lfe;
@@ -40,6 +41,7 @@ typedef struct AudioSurroundContext {
     float highcut;
 
     uint64_t out_channel_layout;
+    uint64_t in_channel_layout;
     int nb_in_channels;
     int nb_out_channels;
 
@@ -55,6 +57,7 @@ typedef struct AudioSurroundContext {
 
     int64_t pts;
 
+    void (*filter)(AVFilterContext *ctx);
     void (*upmix)(AVFilterContext *ctx,
                   float l_phase,
                   float r_phase,
@@ -62,6 +65,14 @@ typedef struct AudioSurroundContext {
                   float mag_total,
                   float x, float y,
                   int n);
+    void (*upmix_surround)(AVFilterContext *ctx,
+                  float l_phase,
+                  float r_phase,
+                  float c_mag,
+                  float c_phase,
+                  float mag_total,
+                  float x, float y,
+                  int n);
 } AudioSurroundContext;
 
 static int query_formats(AVFilterContext *ctx)
@@ -88,7 +99,7 @@ static int query_formats(AVFilterContext *ctx)
         return ret;
 
     layouts = NULL;
-    ret = ff_add_channel_layout(&layouts, AV_CH_LAYOUT_STEREO);
+    ret = ff_add_channel_layout(&layouts, s->in_channel_layout);
     if (ret)
         return ret;
 
@@ -313,6 +324,41 @@ static void upmix_3_1(AVFilterContext *ctx,
     dstlfe[2 * n + 1] = lfe_mag * sinf(c_phase);
 }
 
+static void upmix_3_1_surround(AVFilterContext *ctx,
+                               float l_phase,
+                               float r_phase,
+                               float c_phase,
+                               float c_mag,
+                               float mag_total,
+                               float x, float y,
+                               int n)
+{
+    AudioSurroundContext *s = ctx->priv;
+    float lfe_mag, l_mag, r_mag, *dstc, *dstl, *dstr, *dstlfe;
+
+    dstl = (float *)s->output->extended_data[0];
+    dstr = (float *)s->output->extended_data[1];
+    dstc = (float *)s->output->extended_data[2];
+    dstlfe = (float *)s->output->extended_data[3];
+
+    get_lfe(s->output_lfe, n, s->lowcut, s->highcut, &lfe_mag, &c_mag);
+
+    l_mag = sqrtf(.5f * ( x + 1.f)) * ((y + 1.f) * .5f) * mag_total;
+    r_mag = sqrtf(.5f * (-x + 1.f)) * ((y + 1.f) * .5f) * mag_total;
+
+    dstl[2 * n    ] = l_mag * cosf(l_phase);
+    dstl[2 * n + 1] = l_mag * sinf(l_phase);
+
+    dstr[2 * n    ] = r_mag * cosf(r_phase);
+    dstr[2 * n + 1] = r_mag * sinf(r_phase);
+
+    dstc[2 * n    ] = c_mag * cosf(c_phase);
+    dstc[2 * n + 1] = c_mag * sinf(c_phase);
+
+    dstlfe[2 * n    ] = lfe_mag * cosf(c_phase);
+    dstlfe[2 * n + 1] = lfe_mag * sinf(c_phase);
+}
+
 static void upmix_4_0(AVFilterContext *ctx,
                       float l_phase,
                       float r_phase,
@@ -471,6 +517,52 @@ static void upmix_5_1_back(AVFilterContext *ctx,
     dstrs[2 * n + 1] = rs_mag * sinf(r_phase);
 }
 
+static void upmix_5_1_back_surround(AVFilterContext *ctx,
+                                    float l_phase,
+                                    float r_phase,
+                                    float c_phase,
+                                    float c_mag,
+                                    float mag_total,
+                                    float x, float y,
+                                    int n)
+{
+    AudioSurroundContext *s = ctx->priv;
+    float lfe_mag, l_mag, r_mag, *dstc, *dstl, *dstr, *dstlfe;
+    float ls_mag, rs_mag, *dstls, *dstrs;
+
+    dstl = (float *)s->output->extended_data[0];
+    dstr = (float *)s->output->extended_data[1];
+    dstc = (float *)s->output->extended_data[2];
+    dstlfe = (float *)s->output->extended_data[3];
+    dstls = (float *)s->output->extended_data[4];
+    dstrs = (float *)s->output->extended_data[5];
+
+    get_lfe(s->output_lfe, n, s->lowcut, s->highcut, &lfe_mag, &c_mag);
+
+    l_mag = sqrtf(.5f * ( x + 1.f)) * ((y + 1.f) * .5f) * mag_total;
+    r_mag = sqrtf(.5f * (-x + 1.f)) * ((y + 1.f) * .5f) * mag_total;
+    ls_mag = sqrtf(.5f * ( x + 1.f)) * (1.f - ((y + 1.f) * .5f)) * mag_total;
+    rs_mag = sqrtf(.5f * (-x + 1.f)) * (1.f - ((y + 1.f) * .5f)) * mag_total;
+
+    dstl[2 * n    ] = l_mag * cosf(l_phase);
+    dstl[2 * n + 1] = l_mag * sinf(l_phase);
+
+    dstr[2 * n    ] = r_mag * cosf(r_phase);
+    dstr[2 * n + 1] = r_mag * sinf(r_phase);
+
+    dstc[2 * n    ] = c_mag * cosf(c_phase);
+    dstc[2 * n + 1] = c_mag * sinf(c_phase);
+
+    dstlfe[2 * n    ] = lfe_mag * cosf(c_phase);
+    dstlfe[2 * n + 1] = lfe_mag * sinf(c_phase);
+
+    dstls[2 * n    ] = ls_mag * cosf(l_phase);
+    dstls[2 * n + 1] = ls_mag * sinf(l_phase);
+
+    dstrs[2 * n    ] = rs_mag * cosf(r_phase);
+    dstrs[2 * n + 1] = rs_mag * sinf(r_phase);
+}
+
 static void upmix_7_0(AVFilterContext *ctx,
                       float l_phase,
                       float r_phase,
@@ -577,6 +669,71 @@ static void upmix_7_1(AVFilterContext *ctx,
     dstrs[2 * n + 1] = rs_mag * sinf(r_phase);
 }
 
+static void filter_stereo(AVFilterContext *ctx)
+{
+    AudioSurroundContext *s = ctx->priv;
+    float *srcl, *srcr;
+    int n;
+
+    srcl = (float *)s->input->extended_data[0];
+    srcr = (float *)s->input->extended_data[1];
+
+    for (n = 0; n < s->buf_size; n++) {
+        float l_re = srcl[2 * n], r_re = srcr[2 * n];
+        float l_im = srcl[2 * n + 1], r_im = srcr[2 * n + 1];
+        float c_phase = atan2f(l_im + r_im, l_re + r_re);
+        float l_mag = hypotf(l_re, l_im);
+        float r_mag = hypotf(r_re, r_im);
+        float l_phase = atan2f(l_im, l_re);
+        float r_phase = atan2f(r_im, r_re);
+        float phase_dif = fabsf(l_phase - r_phase);
+        float mag_dif = (l_mag - r_mag) / (l_mag + r_mag);
+        float mag_total = hypotf(l_mag, r_mag);
+        float x, y;
+
+        if (phase_dif > M_PI)
+            phase_dif = 2 * M_PI - phase_dif;
+
+        stereo_position(mag_dif, phase_dif, &x, &y);
+
+        s->upmix(ctx, l_phase, r_phase, c_phase, mag_total, x, y, n);
+    }
+}
+
+static void filter_surround(AVFilterContext *ctx)
+{
+    AudioSurroundContext *s = ctx->priv;
+    float *srcl, *srcr, *srcc;
+    int n;
+
+    srcl = (float *)s->input->extended_data[0];
+    srcr = (float *)s->input->extended_data[1];
+    srcc = (float *)s->input->extended_data[2];
+
+    for (n = 0; n < s->buf_size; n++) {
+        float l_re = srcl[2 * n], r_re = srcr[2 * n];
+        float l_im = srcl[2 * n + 1], r_im = srcr[2 * n + 1];
+        float c_re = srcc[2 * n], c_im = srcc[2 * n + 1];
+        float c_mag = hypotf(c_re, c_im);
+        float c_phase = atan2f(c_im, c_re);
+        float l_mag = hypotf(l_re, l_im);
+        float r_mag = hypotf(r_re, r_im);
+        float l_phase = atan2f(l_im, l_re);
+        float r_phase = atan2f(r_im, r_re);
+        float phase_dif = fabsf(l_phase - r_phase);
+        float mag_dif = (l_mag - r_mag) / (l_mag + r_mag);
+        float mag_total = hypotf(l_mag, r_mag);
+        float x, y;
+
+        if (phase_dif > M_PI)
+            phase_dif = 2 * M_PI - phase_dif;
+
+        stereo_position(mag_dif, phase_dif, &x, &y);
+
+        s->upmix_surround(ctx, l_phase, r_phase, c_phase, c_mag, mag_total, x, y, n);
+    }
+}
+
 static int init(AVFilterContext *ctx)
 {
     AudioSurroundContext *s = ctx->priv;
@@ -584,54 +741,84 @@ static int init(AVFilterContext *ctx)
     int i;
 
     if (!(s->out_channel_layout = av_get_channel_layout(s->out_channel_layout_str))) {
-        av_log(ctx, AV_LOG_ERROR, "Error parsing channel layout '%s'.\n",
+        av_log(ctx, AV_LOG_ERROR, "Error parsing output channel layout '%s'.\n",
                s->out_channel_layout_str);
         return AVERROR(EINVAL);
     }
 
+    if (!(s->in_channel_layout = av_get_channel_layout(s->in_channel_layout_str))) {
+        av_log(ctx, AV_LOG_ERROR, "Error parsing input channel layout '%s'.\n",
+               s->in_channel_layout_str);
+        return AVERROR(EINVAL);
+    }
+
     if (s->lowcutf >= s->highcutf) {
         av_log(ctx, AV_LOG_ERROR, "Low cut-off '%d' should be less than high cut-off '%d'.\n",
                s->lowcutf, s->highcutf);
         return AVERROR(EINVAL);
     }
 
-    switch (s->out_channel_layout) {
-    case AV_CH_LAYOUT_MONO:
-        s->upmix = upmix_1_0;
-        break;
+    switch (s->in_channel_layout) {
     case AV_CH_LAYOUT_STEREO:
-        s->upmix = upmix_stereo;
-        break;
-    case AV_CH_LAYOUT_2POINT1:
-        s->upmix = upmix_2_1;
+        s->filter = filter_stereo;
+        switch (s->out_channel_layout) {
+        case AV_CH_LAYOUT_MONO:
+            s->upmix = upmix_1_0;
+            break;
+        case AV_CH_LAYOUT_STEREO:
+            s->upmix = upmix_stereo;
+            break;
+        case AV_CH_LAYOUT_2POINT1:
+            s->upmix = upmix_2_1;
+            break;
+        case AV_CH_LAYOUT_SURROUND:
+            s->upmix = upmix_3_0;
+            break;
+        case AV_CH_LAYOUT_3POINT1:
+            s->upmix = upmix_3_1;
+            break;
+        case AV_CH_LAYOUT_4POINT0:
+            s->upmix = upmix_4_0;
+            break;
+        case AV_CH_LAYOUT_4POINT1:
+            s->upmix = upmix_4_1;
+            break;
+        case AV_CH_LAYOUT_5POINT0_BACK:
+            s->upmix = upmix_5_0_back;
+            break;
+        case AV_CH_LAYOUT_5POINT1_BACK:
+            s->upmix = upmix_5_1_back;
+            break;
+        case AV_CH_LAYOUT_7POINT0:
+            s->upmix = upmix_7_0;
+            break;
+        case AV_CH_LAYOUT_7POINT1:
+            s->upmix = upmix_7_1;
+            break;
+        default:
+            av_log(ctx, AV_LOG_ERROR, "Unsupported output channel layout '%s'.\n",
+                   s->out_channel_layout_str);
+            return AVERROR(EINVAL);
+        }
         break;
     case AV_CH_LAYOUT_SURROUND:
-        s->upmix = upmix_3_0;
-        break;
-    case AV_CH_LAYOUT_3POINT1:
-        s->upmix = upmix_3_1;
-        break;
-    case AV_CH_LAYOUT_4POINT0:
-        s->upmix = upmix_4_0;
-        break;
-    case AV_CH_LAYOUT_4POINT1:
-        s->upmix = upmix_4_1;
-        break;
-    case AV_CH_LAYOUT_5POINT0_BACK:
-        s->upmix = upmix_5_0_back;
-        break;
-    case AV_CH_LAYOUT_5POINT1_BACK:
-        s->upmix = upmix_5_1_back;
-        break;
-    case AV_CH_LAYOUT_7POINT0:
-        s->upmix = upmix_7_0;
-        break;
-    case AV_CH_LAYOUT_7POINT1:
-        s->upmix = upmix_7_1;
+        s->filter = filter_surround;
+        switch (s->out_channel_layout) {
+        case AV_CH_LAYOUT_3POINT1:
+            s->upmix_surround = upmix_3_1_surround;
+            break;
+        case AV_CH_LAYOUT_5POINT1_BACK:
+            s->upmix_surround = upmix_5_1_back_surround;
+            break;
+        default:
+            av_log(ctx, AV_LOG_ERROR, "Unsupported output channel layout '%s'.\n",
+                   s->out_channel_layout_str);
+            return AVERROR(EINVAL);
+        }
         break;
     default:
-        av_log(ctx, AV_LOG_ERROR, "Unsupported output channel layout '%s'.\n",
-               s->out_channel_layout_str);
+        av_log(ctx, AV_LOG_ERROR, "Unsupported input channel layout '%s'.\n",
+               s->in_channel_layout_str);
         return AVERROR(EINVAL);
     }
 
@@ -714,9 +901,8 @@ static int filter_frame(AVFilterLink *inlink, AVFrame *in)
     av_frame_free(&in);
 
     while (av_audio_fifo_size(s->fifo) >= s->buf_size) {
-        float *srcl, *srcr;
         AVFrame *out;
-        int n, ret;
+        int ret;
 
         ret = av_audio_fifo_peek(s->fifo, (void **)s->input->extended_data, s->buf_size);
         if (ret < 0)
@@ -724,29 +910,7 @@ static int filter_frame(AVFilterLink *inlink, AVFrame *in)
 
         ctx->internal->execute(ctx, fft_channel, NULL, NULL, inlink->channels);
 
-        srcl = (float *)s->input->extended_data[0];
-        srcr = (float *)s->input->extended_data[1];
-
-        for (n = 0; n < s->buf_size; n++) {
-            float l_re = srcl[2 * n], r_re = srcr[2 * n];
-            float l_im = srcl[2 * n + 1], r_im = srcr[2 * n + 1];
-            float c_phase = atan2f(l_im + r_im, l_re + r_re);
-            float l_mag = hypotf(l_re, l_im);
-            float r_mag = hypotf(r_re, r_im);
-            float l_phase = atan2f(l_im, l_re);
-            float r_phase = atan2f(r_im, r_re);
-            float phase_dif = fabsf(l_phase - r_phase);
-            float mag_dif = (l_mag - r_mag) / (l_mag + r_mag);
-            float mag_total = hypotf(l_mag, r_mag);
-            float x, y;
-
-            if (phase_dif > M_PI)
-                phase_dif = 2 * M_PI - phase_dif;
-
-            stereo_position(mag_dif, phase_dif, &x, &y);
-
-            s->upmix(ctx, l_phase, r_phase, c_phase, mag_total, x, y, n);
-        }
+        s->filter(ctx);
 
         out = ff_get_audio_buffer(outlink, s->hop_size);
         if (!out)
@@ -792,6 +956,7 @@ static av_cold void uninit(AVFilterContext *ctx)
 
 static const AVOption surround_options[] = {
     { "chl_out",   "set output channel layout", OFFSET(out_channel_layout_str), AV_OPT_TYPE_STRING, {.str="5.1"}, 0,   0, FLAGS },
+    { "chl_in",    "set input channel layout",  OFFSET(in_channel_layout_str),  AV_OPT_TYPE_STRING, {.str="stereo"},0, 0, FLAGS },
     { "level_in",  "set input level",           OFFSET(level_in),               AV_OPT_TYPE_FLOAT,  {.dbl=1},     0,  10, FLAGS },
     { "level_out", "set output level",          OFFSET(level_out),              AV_OPT_TYPE_FLOAT,  {.dbl=1},     0,  10, FLAGS },
     { "lfe",       "output LFE",                OFFSET(output_lfe),             AV_OPT_TYPE_BOOL,   {.i64=1},     0,   1, FLAGS },